nextstep/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('story7.urls')),
    path('books/', include('story8.urls')),
    path('',include('story9.urls')),
]

story7/urls.py
from django.urls import path
from . import views

app_name = 'story7'

urlpatterns = [
    path('story7/', views.accordion, name='accordion'),
    # dilanjutkan ...
]

story8/urls.py
from django.contrib import admin
from django.urls import path
from .views import searchbook, data

app_name = 'story8'

urlpatterns = [
    path('', searchbook, name='searchbook'),
    path('data/', data, name='data'),
]

story9/urls.py
from django.urls import path
from .views import logIn, signUp, logOut

urlpatterns = [
    path('', logIn, name='login'),
    path('signup/', signUp, name='signup'),
    path('logout/', logOut, name='logout'),
]

story7/models.py
from django.db import models

# Create your models here.

story8/models.py
from django.db import models

# Create your models here.

story9/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.

story9/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm


class LoginForm(AuthenticationForm):
    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signIn-username',
        'placeholder' : 'Username',
        'type' : 'text',
        'style' : 'width: 20vw;',
        'required' : True
    }))

    password = forms.CharField(label="Password", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signIn-password',
        'placeholder' : 'Password',
        'type' : 'password',
        'style' : 'width: 20vw;',
        'required' : True
    }))

class SignUpForm(UserCreationForm):
    first_name = forms.CharField(label="First name", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-firstName',
        'placeholder' : 'First name',
        'type' : 'text',
        'style' : 'width: 30vw;',
        'required' : True
    }))

    last_name = forms.CharField(label="Last name", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'placeholder' : 'Last name',
        'id' : 'signUp-lastName',
        'type' : 'text',
        'style' : 'width: 30vw;',
        'required' : True
    }))

    username = forms.CharField(label="Username", widget=forms.TextInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-username',
        'placeholder' : 'Username',
        'type' : 'text',
        'style' : 'width: 30vw;',
        'required' : True
    }))

    password1 = forms.CharField(label="Password", widget=forms.PasswordInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-password1',
        'placeholder' : 'Password',
        'type' : 'password',
        'style' : 'width: 30vw;',
        'required' : True
    }))
    password2 = forms.CharField(label="Confirm password", widget=forms.PasswordInput(attrs={
        'class' : 'form-control',
        'id' : 'signUp-password2',
        'placeholder' : 'Confirm Password',
        'type' : 'password',
        'style' : 'width: 30vw;',
        'required' : True
    }))

class Meta:
    model = User
    fields = ['first_name', 'last_name', 'username', 'password1', 'password2']

story7/views.py
from django.shortcuts import render

# Create your views here.
def accordion(request):
    return render(request, 'accordion.html')

story8/views.py
from django.shortcuts import render
from django.http import JsonResponse
import requests
import json

# Create your views here.
def data(request):
	try:
		q = request.GET['q']

	except:
		q = 'quilting'

	json_read = requests.get('https://www.googleapis.com/books/v1/volumes?q=' + q).json()
	return JsonResponse(json_read)
    
def searchbook(request):
	return render(request,'searchbook.html')

story9/views.py
from django.shortcuts import render, redirect
from .forms import LoginForm, SignUpForm
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm


# Create your views here.
def logIn(request):
    if request.method == "POST":
        form = LoginForm(data = request.POST)

        if form.is_valid():
            usernameInput = request.POST["username"]
            passwordInput = request.POST["password"]

            print(usernameInput, passwordInput)
            user = authenticate(request, username = usernameInput, password = passwordInput)

            if user is not None:
                login(request, user)
                return redirect('login')

        else:
            messages.error(request, 'Invalid entry')

    else:
        form = LoginForm()

    context = {
        "form" : form,
    }

    return render(request, "login.html", context)

def signUp(request):
    if request.method == 'POST':
        form = SignUpForm(request.POST)

        if form.is_valid():
            user = form.save()
            login(request, user)
            return redirect("login")

        else:
            for msg in form.error_messages:
                messages.error(request, 'Invalid entry')

    else:
        form = SignUpForm()

    context = {
        'form' : form
    }

    return render(request, "signup.html", context)

def logOut(request):
    logout(request)
    return redirect("login")

story7/templates/accordion.html
{% extends 'base.html' %}
{% load static %}

{% block head %}
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <link rel="stylesheet" href="{% static 'accordion.css' %}">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css" integrity="sha384-HSMxcRTRxnN+Bdg0JdbxYKrThecOKuH5zCYotlSAcp1+c8xmyTe9GYg1l9a69psu" crossorigin="anonymous">
  <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
  <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
  <title>The Next Journey</title>
{% endblock head %}

{% block content %}
<div class="container">
    <div class="jumbotron rounded">
        <div class="typewriter">
            <h1 style="color: black;">Welcome to <br>The Next Journey of <br><b style="color: grey;">Shafna</b> :D</h1>
        </div>
        <br>
          <p><strong>Here Are a Few Things About Me,</strong></p>
    </div>
</div>

<div class="container">
  <div class="panel-group" id="accordion">
    <div class="panel panel-info satu">
        <div class="panel-heading">
            <span class = "pull-right">
                <div class="accordion-buttons col-2 d-flex justify-content-flex">
                  <div class="button-up">
                      <button type="button" id="button-up" data-parent=#accordion class="btn btn-default up glyphicon glyphicon-chevron-up"></button>
                  </div>
                  <div class="button-down">
                      <button type="button" id="button-down" data-parent=#accordion class="btn btn-default up glyphicon glyphicon-chevron-down"></button>
                  </div>
                </div>
              </span>
          <h4 class="panel-title">
              <button class="btn btn-link collapsed" type="button" data-parent=#accordion data-toggle="collapse"
              data-target="#collapse1" aria-expanded="false" aria-controls="collapse1">
              <strong> Recent Activities </strong>
            </button>
          </h4>
        </div>
        <div id="collapse1" class="panel-collapse collapse">
          <div class="panel-body">
            <ul>
              Kuliah
              <br>Kuliah
              <br>Kuliah
            </ul>
          </div>
        </div>
      </div>
      <div class="panel panel-info dua">
          <div class="panel-heading">
              <span class = "pull-right">
                  <div class="accordion-buttons col-2 d-flex justify-content-flex">
                      <div class="button-up">
                          <button type="button" id="button-up" data-parent=#accordion class="btn btn-default glyphicon glyphicon-chevron-up"></button>
                      </div>
                      <div class="button-down">
                          <button type="button" id="button-down" data-parent=#accordion class="btn btn-default glyphicon glyphicon-chevron-down"></button>
                      </div>
                    </div>
                </span>
            <h4 class="panel-title">
                <button class="btn btn-link collapsed" type="button" data-parent=#accordion data-toggle="collapse"
                data-target="#collapse2" aria-expanded="false" aria-controls="collapse3">
                <strong> Experiences</strong>
              </button>
            </h4>
          </div>
          <div id="collapse2" class="panel-collapse collapse">
            <div class="panel-body">
                <ul>
                  Staff BEM Fasilkom UI 2020
                </ul>
                <ul>
                  and more..
                </ul>
            </div>
          </div>
        </div>
  <div class="panel panel-info tiga">
    <div class="panel-heading">
        <span class = "pull-right">
            <div class="accordion-buttons col-2 d-flex justify-content-flex">
                <div class="button-up">
                    <button type="button" id="button-up" data-parent=#accordion class="btn btn-default up glyphicon glyphicon-chevron-up"></button>
                </div>
                <div class="button-down">
                    <button type="button" id="button-down" data-parent=#accordion class="btn btn-default up glyphicon glyphicon-chevron-down"></button>
                </div>
              </div>
          </span>
      <h4 class="panel-title">
          <button class="btn btn-link collapsed" type="button" data-parent=#accordion data-toggle="collapse"
          data-target="#collapse3" aria-expanded="false" aria-controls="collapse3">
          <strong> Achievements </strong>
        </button>
      </h4>
    </div>
    <div id="collapse3" class="panel-collapse collapse">
      <div class="panel-body">
          <ul>
            Soon ~~
          </ul>
      </div>
    </div>
  </div>
  <div class="panel panel-info empat">
    <div class="panel-heading">
        <span class = "pull-right">
            <div class="accordion-buttons col-2 d-flex justify-content-flex">
                <div class="button-up">
                    <button type="button" data-parent=#accordion class="btn btn-default up glyphicon glyphicon-chevron-up"></button>
                </div>
                <div class="button-down">
                    <button type="button" data-parent=#accordion class="btn btn-default up glyphicon glyphicon-chevron-down"></button>
                </div>
              </div>
          </span>
      <h4 class="panel-title">
          <button class="btn btn-link collapsed" type="button" data-parent=#accordion data-toggle="collapse"
          data-target="#collapse4" aria-expanded="false" aria-controls="collapse4">
          <strong> Hobies </strong>
        </button>
      </h4>
    </div>
    <div id="collapse4" class="panel-collapse collapse">
      <div class="panel-body">
          <ul>
            Baking 😋 
          </ul>
          <ul>
            Tidur
          </ul>
          <ul>
            Jalan-jalan dikit 
          </ul>
      </div>
    </div>
  </div> 
</div>
</div>

<script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
<script src="{% static 'accordion.js' %}"></script>
{% endblock content %}

story7/templates/base.html
<!DOCTYPE html>
{% load static %}
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    {% block head %}
    {% endblock head %}
    <link href="https://fonts.googleapis.com/css?family=Poppins" rel="stylesheet">
  </head>

  <body>
    <div class="fixed-top">
    <nav class="navbar fixed-top navbar-expand-lg navbar-dark bg-dark">
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavDropdown" aria-controls="navbarNavDropdown" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarNavDropdown">
    <ul class="navbar-nav">
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          Story
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
          <a class="dropdown-item" href="{% url 'story7:accordion' %}">Story 7</a>
          <a class="dropdown-item" href="{% url 'story8:searchbook' %}">Story 8</a>
          <a class="dropdown-item" href="{% url 'login' %}">Log in</a>
        </div>
      </li>
    </ul>
  </div>
</nav>
</div>
        {% block content %}
        {% endblock content %}
  </body>
    <script
      src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
      integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
      integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV"
      crossorigin="anonymous"
    ></script>
    
</html>

story8/templates/searchbook.html
{% extends 'base.html' %}
{% load static %}

{% block head %}
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Montserrat:400,700&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="{% static 'css/searchbook.css' %}" />
    <title>Search Book</title>
{% endblock head %}

{% block content %}
    <div class="SearchBook">
        <div class="d-flex justify-content-center">
            <h1 class="judulSearchBook">
                <b name="judul">Search Book</b>
            </h1>
        </div>
        <div class="SearchBook2">
            <input type="text" id="textField" name="searchbar" placeholder="Search for books.." title="Type in a name">
        </div>
        <div class="table-responsive" id="Table">
            <table class="table table-hover">
                <thead>
                    <tr class="table text-center">
                        <th scope="col" style="color: beige">No</th>
                        <th scope="col" style="color: beige">Cover</th>
                        <th scope="col" style="color: beige">Title</th>
                        <th scope="col" style="color: beige">Authors</th>
                        <th scope="col" style="color: beige">Publisher</th>
                        <th scope="col" style="color: beige">Published Date</th>
                    </tr>
                </thead>
                <tbody id="hasilSearch" style="color: beige;"></tbody>
            </table>
        </div>
    </div>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>
    <script src="{% static 'js/searchbook.js' %}"></script>
{% endblock content %}

story9/templates/login.html
{% extends 'base.html' %}

{% load static %}

{% block head %}
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
<link href="https://fonts.googleapis.com/css?family=Montserrat:400,700&display=swap" rel="stylesheet">
    <title>Log in</title>
    <style>
        body{color: white;}
    </style>
{% endblock head %}

{% block content %}


<div class="main-story10 d-flex flex-column justify-content-center">

        <div class="right-page col justify-content-center">
            {% if user.is_authenticated == False %}
            <div class="login content mx-5 my-5">
                {% if messages %}
                    {% for message in messages %}
                        <p>{{message}}</p>
                    {% endfor %}
                {% endif %}
                <div class="title">
                    <h3>Sign in</h3>
                </div>
                <div class="login-form">
                    <form method="POST">
                        {% csrf_token %} 
                        {{ form }}
                        <div>
                            <button type="submit" name="btn-login" id="btn-logIn" class="btn btn-dark mt-4">LOGIN</button>
                        </div>
                    </form>
                </div>

                <div class="info mt-5">
                    <p>
                        Don't have an account? <a class="sign-up-in-link" href="{% url 'signup' %}"><strong>Sign up.</strong></a>
                    </p>
                </div>
            </div>

            {% else %}
                <div class="success mt-5 ml-5">
                    <div class="btn-logout">
                        <form action="{% url 'logout' %}">
                            <input type="submit" id="btn-logOut" class="btn btn-dark" value="Log out">
                        </form>
                    </div>

                    <div class="greeting mt-5">
                        <h3>Welcome,</h3>
                        <h1 style="font-weight: 800px;"><span class="highlight">{{user.username}}.</span></h1>
                        <h4 style="font-weight: 800px;"><span class="highlight">{{user.profile.bio}}.</span></h4>
                        <h4 style="font-weight: 800px;"><span class="highlight">{{user.profile.img}}.</span></h4>
                    </div>
                </div>
            {% endif %}
        </div>
    </div>


</div>

<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>


{% endblock content %}

story9/templates/signup.html
{% extends 'base.html' %}

{% block head %}
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
<link href="https://fonts.googleapis.com/css?family=Montserrat:400,700&display=swap" rel="stylesheet">
    <title>Log in</title>
    <style>
        body{color: white;}
    </style>
    <title>Sign up</title>
{% endblock head %}


{% load static %}
{% block content %}

<div class="main-story10 d-flex flex-column justify-content-center">
    {% if messages %}
        {% for message in messages %}
            <p>{{message}}</p>
        {% endfor %}
    {% endif %}

        <div class="right-page col">
            <div class="login-content mx-5 my-5">

                <div class="title">
                    <h3>Create a new account</h3>
                </div>
            
            <div class="register-form">
                <form method="POST">
                    {% csrf_token %} 
                    {{ form }}
                    <div>
                        <button type="submit" name="btn-signup" id='btn-signUp' class="btn btn-dark mt-4">SIGN UP</button>
                    </div>
                </form>
            </div>
        
            <div class="info mt-5">
                <p>
                    Have an account already? <a class="sign-up-in-link" href="{% url 'login' %}"><strong>Sign in.</strong></a>
                </p>
            </div>
        </div>
    </div> 
</div>

<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>

{% endblock content %}